%define section   free
%define base_name slide
%define jakarta_version 2.0

Name:           jakarta-%{base_name}-server
Version:        %{jakarta_version}
Release:        0.b1.1jpp
Epoch:          0
Summary:        Slide content repository server

Group:          Internet/WWW/Servers
License:        Apache Software License
URL:            http://jakarta.apache.org/slide/
Source0:        jakarta-slide-server-2.0b1-src.tar.gz
Patch0:         jakarta-slide-server-XMLResourceDescriptor.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} )
Distribution:   JPackage
Vendor:         JPackage Project
BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.5.32
BuildRequires:  ant >= 0:1.5.4, ant-optional >= 0:1.5.4 junit >= 0:3.8.1
BuildRequires:  tomcat4 >= 0:4.1.29
BuildRequires:  jakarta-commons-collections >= 0:2.1
BuildRequires:  jakarta-commons-dbcp >= 0:1.1
BuildRequires:  jakarta-commons-pool >= 0:1.1
BuildRequires:  jta >= 0:1.0.1
BuildRequires:  jdom >= 0:1.0
BuildRequires:  log4j >= 0:1.2.8
BuildRequires:  mx4j >= 0:1.1.1
BuildRequires:  servletapi4 >= 0:4.0.4
BuildRequires:  xerces-j2 >= 0:2.6.0
BuildRequires:  xml-commons-apis >= 0:1.0
Requires:  jakarta-commons-collections >= 0:2.1
Requires:  jakarta-commons-dbcp >= 0:1.1
Requires:  jakarta-commons-pool >= 0:1.1
Requires:  jta >= 0:1.0.1
Requires:  jdom >= 0:1.0
Requires:  log4j >= 0:1.2.8
Requires:  mx4j >= 0:1.1.1
Requires:  servletapi4 >= 0:4.0.4
Requires:  xerces-j2 >= 0:2.6.0
Requires:  xml-commons-apis >= 0:1.0

%description
Slide is a content repository which can serve as 
a basis for a content management system / framework 
and other purposes. It features:
+ Full WebDAV Support 
+ Basic DeltaV WebDAV Versioning Support 
+ Support for a variety of backend systems for 
  storing the content including different databases 
  and file system storage 
+ Transactions and Locking for data integrity 
+ Flexible control over permissions at a per file level 
  via support for the WebDAV ACL 
+ DASL support for any backend, extensible for using 
  backends search capabilities for higher scalability 
  and less latency 
+ Binding support 
+ Simple installation on any server supporting 
  Servlet 2.3 and .war deployment 
+ 'ready-to-run' binary distribution for Tomcat 
+ A fully featured WebDAV client library and command 
  line client 

%package        webapps-tc4
Summary:        Tomcat4-webapps for %{name}
Group:          Internet/WWW/Servers
Requires:       jakarta-slide-server = 0:2.0-0.b1.1jpp
Requires:       tomcat4 >= 0:4.1.29

%description    webapps-tc4
%{summary}.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.


%prep
%setup -q -n jakarta-slide-2.0b1-src
find . -name "*.jar" -exec rm {} \;
echo >> src/stores/org/apache/slide/store/txfile/XMLResourceDescriptor.java
cat > build.properties << EOT
catalina.dist=/var/lib/tomcat4
catalina.server.lib=\${catalina.dist}/server/lib
catalina.common.lib=\${catalina.dist}/common/lib
catalina.jar=\${catalina.server.lib}/catalina.jar
EOT

%patch0

%build
export CLASSPATH=$(build-classpath \
commons-collections \
commons-dbcp \
commons-pool \
jta \
jdom \
log4j \
mx4j/mx4j-jmx \
servletapi4 \
xerces-j2 \
xml-commons-apis \
junit)
ant -Dbuild.sysclasspath=first full-dist


%install
rm -rf $RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{base_name}
install -pm 644 \
 dist/slide/lib/%{base_name}-kernel-%{jakarta_version}b1.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-kernel-%{version}.jar
install -pm 644 \
 dist/slide/lib/%{base_name}-jdk14logger-%{jakarta_version}b1.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-jdk14logger-%{version}.jar
install -pm 644 \
 dist/slide/lib/%{base_name}-log4jlogger-%{jakarta_version}b1.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-log4jlogger-%{version}.jar
install -pm 644 \
 dist/slide/lib/%{base_name}-roles-%{jakarta_version}b1.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-roles-%{version}.jar
install -pm 644 \
 dist/slide/lib/%{base_name}-stores-%{jakarta_version}b1.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-stores-%{version}.jar
install -pm 644 \
 dist/slide/lib/%{base_name}-webdavservlet-%{jakarta_version}b1.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-webdavservlet-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name} && for jar in jakarta-*.jar; do ln -sf ${jar} `echo $jar| sed  "s|jakarta-||g"`; done)
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -pm 644 dist/slide/conf/* \
        $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/wrappers
install -pm 644 \
 dist/slide/wrappers/%{base_name}-catalinawrapper-%{jakarta_version}b1.jar \
 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/wrappers/%{name}-catalinawrapper-%{version}.jar
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/webapp
install -pm 644 \
 dist/slide/webapp/%{base_name}.war \
 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/webapp/%{base_name}-%{version}.war
install -pm 644 \
 dist/slide/webapp/%{base_name}-doc.war \
 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/webapp/%{base_name}-doc-%{version}.war

#javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/doc/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf dist/doc/javadoc

#manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr dist/doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}


%files
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}/LICENSE
%{_javadir}/%{base_name}/*.jar
%{_datadir}/%{name}-%{version}/conf
%{_datadir}/%{name}-%{version}/wrappers

%files webapps-tc4
%defattr(-,root,root,-)
%{_datadir}/%{name}-%{version}/webapp

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Fri Mar 05 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-0.b1.1jpp
- First JPackage release
